
<?php
#########Module Version 1.4beta####### OCT 16th 2017##############
#########What's new?#########
#1.none
########Bug fixed#########
#1.Incomplete information when retriving XML from API server #Fixed by chenwp
#2.Not able to save registrant contact #Luke
#known bugs:
#UnKnown
#########Module Version 1.3####### AUG 11th 2017#######Luke#######
#########what's new?##########
#1.Added Module Logging    #Luke 
#2.Fixed a Bug in SavecontactDetails   # Luke
#3.Fix bug and support Uk Registration/Renewal/management # Luke
#History Changelog：
#########known BUG:########### 
#1.Incomplete information when retriving XML from API server
#NONE

#######Module V1.2 ####### July 11th 2017#######Luke#######
##########what's new?#########
#Removed logout
#1.Delete domain
#2.bug fixed
##########Known bugs##########
#1.cannot register .co.uk ， we can create .uk domain contact but cannot register. 
#2.Incomplete information when retriving XML from API server
 

class onlinenic_Punycode
{
	private static $DECODE_TABLE = array(
		'a' =>  0, 'b' =>  1, 'c' =>  2, 'd' =>  3, 'e' =>  4, 'f' =>  5,
		'g' =>  6, 'h' =>  7, 'i' =>  8, 'j' =>  9, 'k' => 10, 'l' => 11,
		'm' => 12, 'n' => 13, 'o' => 14, 'p' => 15, 'q' => 16, 'r' => 17,
		's' => 18, 't' => 19, 'u' => 20, 'v' => 21, 'w' => 22, 'x' => 23,
		'y' => 24, 'z' => 25, '0' => 26, '1' => 27, '2' => 28, '3' => 29,
		'4' => 30, '5' => 31, '6' => 32, '7' => 33, '8' => 34, '9' => 35
	);
	private static $ENCODE_TABLE = array(
		'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',
		'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x',
		'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'
	);
	const BASE = 36;
	const TMIN = 1;
	const TMAX = 26;
	const SKEW = 38;
	const DAMP = 700;
	const INITIAL_BIAS = 72;
	const INITIAL_N = 0x80;
	const DELIMITER = '-';
	const PREFIX = 'xn--';
	const SUFFIX = '';

	private static $OPTIONS = array(
		'charset' => 'UTF-8'
	);

	public static function set_options($options)
	{
		self::$OPTIONS = array_merge(self::$OPTIONS, (array)$options);
	}

	private static function adapt($delta, $numpoints, $firsttime)
	{
		$delta = (int)($firsttime ? $delta / self::DAMP : $delta / 2);
		$delta += (int)($delta / $numpoints);
		$k = 0;
		while ($delta > (((self::BASE - self::TMIN) * self::TMAX) / 2)) {
			$delta = (int)($delta / (self::BASE - self::TMIN));
			$k += self::BASE;
		}
		return $k + (int)((self::BASE - self::TMIN + 1) * $delta / ($delta + self::SKEW));
	}

	private static function string_from_charcode($charcode)
	{
		return mb_convert_encoding('&#'.$charcode.';', self::$OPTIONS['charset'], 'HTML-ENTITIES');
	}

	private static function charcode_from_string( $string )
	{
		return (int)preg_replace('/^.*?([0-9]+).*$/', '$1', mb_convert_encoding($string, 'HTML-ENTITIES', self::$OPTIONS['charset']));
	}

	public static function urldecode($url)
	{
		return self::urlendecode($url, 'decode');
	}

	public static function urlencode($url)
	{
		return self::urlendecode($url, 'encode');
	}

	private static function urlendecode($url, $func)
	{
		$uri = parse_url($url);
		if (!empty($uri['host'])) {
			foreach (array_unique((array)explode('.', $uri['host'])) as $var) {
				if (($encoded = self::$func($var)) != $var) {
					$url = str_replace($var, $encoded, $url);
				}
			}
		}
		return $url;
	}

	public static function decode($input)
	{
		if (preg_match('/^'. self::PREFIX .'/', $input)) {
			return self::_decode(substr($input, strlen(self::PREFIX)));
		}
		return $input;
	}

	public static function encode($input)
	{
		if (preg_match('/[^\x00-\x7f]/', $input)) {
			return self::PREFIX . self::_encode($input);
		}
		return $input;
	}

	public static function _decode($input)
	{
		$n = self::INITIAL_N;
		$bias = self::INITIAL_BIAS;
		$i = 0;
		$output = null;

		if ($pos = (int)strrpos($input, self::DELIMITER)) {
			$output = substr($input, 0, $pos++);
		}
		$ilen = strlen($input);
		$olen = strlen($output);

		while ($pos < $ilen) {
			$oldi = $i;
			$w = 1;
			$k = 0;
			while ($k += self::BASE) {
				$i += ($digit = self::$DECODE_TABLE[ $input[$pos++] ]) * $w;
				$t = $k <= $bias ? self::TMIN : ($k >= $bias + self::TMAX ? self::TMAX : $k - $bias);
				if ($digit < $t) {
					break;
				}
				$w *= self::BASE - $t;
			}
			$bias = self::adapt($i - $oldi, ++$olen, $oldi == 0);
			$n += (int)($i / $olen);
			$i %= $olen;
			$output = mb_substr($output, 0, $i, self::$OPTIONS['charset']) . self::string_from_charcode($n) . mb_substr($output, $i, $olen - $i, self::$OPTIONS['charset']);
			++$i;
		}
		return $output;
	}

	public static function _encode($input)
	{
		$n = self::INITIAL_N;
		$bias = self::INITIAL_BIAS;
		$delta = 0;
		$output = null;

		$ilen = mb_strlen($input, self::$OPTIONS['charset']);
		$non_basic_codepoints = array();
		$codepoints = array();
		for ($b = 0; $b < $ilen; ++$b) {
			if (($code = ord($char = mb_substr($input, $b, 1, self::$OPTIONS['charset']))) < $n) {
				$output .= $char;
			} else if (!in_array($code = self::charcode_from_string($char), $non_basic_codepoints)) {
				$non_basic_codepoints[] = $code;
			}
			$codepoints[] = $code;
		}

		if (($b = strlen($output)) == $ilen) {
			return $output;
		}
		if ($h = $b) {
			$output .= self::DELIMITER;
		}

		$j = 0;
		sort($non_basic_codepoints);
		while ($h < $ilen) {
			$m = $non_basic_codepoints[$j++];
			$delta += ($m - $n) * ($h + 1);
			$n = $m;

			foreach ($codepoints as $c) {
				if ($c < $n) {
					++$delta;
				} else if ($c == $n) {
					$q = $delta;
					$k = 0;
					while ($k += self::BASE) {
						$t = $k <= $bias ? self::TMIN : ($k >= $bias + self::TMAX ? self::TMAX : $k - $bias);
						if ($q < $t) {
							break;
						}
						$output .= self::$ENCODE_TABLE[$t + (($q - $t) % (self::BASE - $t))];
						$q = (int)(($q - $t) / (self::BASE - $t));
					}
					$output .= self::$ENCODE_TABLE[$q];
					$bias = self::adapt($delta, $h + 1, $h == $b);
					$delta = 0;
					++$h;
				}
			}
			++$delta;
			++$n;
		}
		return $output;
	}

	public static function toASCII($input) {
		$parts = explode('.', $input);
		foreach ($parts as $k => $v) {
			$parts[$k] = self::encode($v);
		}

		return implode('.', $parts);
	}

	public static function toUnicode($input) {
		$parts = explode('.', $input);
		foreach ($parts as $k => $v) {
			$parts[$k] = self::decode($v);
		}

		return implode('.', $parts);
	}
}

class onlinenic_Idn {
    
    public static function encode($domainName) {
        $domainParts = explode('.', $domainName);
        foreach ($domainParts as $k => $v) {
            $domainParts[$k] = onlinenic_Punycode::encode(strtolower($v));
        }

        return implode('.', $domainParts);
    }
    
    public static function decode($domainName) {
        $domainParts = explode('.', $domainName);
        foreach ($domainParts as $k => $v) {
            $domainParts[$k] = onlinenic_Punycode::decode($v);
        }

        return implode('.', $domainParts);
    }
}

class onlinenic_TcpClient {
	protected $link;
	protected $lastMessage;
	
	public function __construct(&$link) {
		$this->link = &$link;
		$this->getResponse();
	}
	
	static public function connect($config) {
		$errno = '';
		$errstr = '';
		$link = fsockopen($config['server'], $config['port'], $errno, $errstr, $config['timeout']);
		if ( $link ) {
			return new onlinenic_TcpClient($link);
		}
		return false;
	}

	public function getResponse() {
		stream_set_timeout($this->link, 60);
		$response = '';
		while ( !feof($this->link) ) {
			$rs = fread($this->link,8192);
			$info = stream_get_meta_data($this->link);
			if ( $info['timed_out'] ) {
				$rs = 'Timed out';
				break;
			}
			$response .= $rs;
			if ( preg_match('|</response>|', $response) ) {
				break;
			}
		}
		if ( $response == '' && $rs ) $response = $rs;
		$this->lastMessage = $response;
		return $response;
	}
	
	public function sendCommand($cmd) {
		fwrite($this->link, $cmd);
		return $this->getResponse();
	}
	
	public function disconnect() {
		if ( $this->link ) {
			fclose($this->link);
		}
	}
	
	public function getLastMessage() {
		return $this->lastMessage;
	}
	
	public function __destruct() {
		$this->disconnect();
	}
}

class onlinenic_ApiClient {
	protected $config;
	protected $client;
	protected $lastResult;
	protected $lastRequest;
	protected $lastResponse;
	
	public function __construct($config) {
			$this->config = $config;
	}
	
	public function login($clid='', $password='') {
		$params = array(
			'clid' => $clid ? $clid : $this->config['user'],
		);
		$password = $password ? $password : $this->config['pass'];
		$cltrid = 'client' . $params['clid'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($params['clid'] . md5($password) . $cltrid . 'login');
		$cmd = $this->buildCommand('client', 'Login', $params, $cltrid, $chksum);
		$client = onlinenic_TcpClient::connect($this->config);
		if ( false === $client ) return false;
		$this->client = &$client;
		$this->writeLog("REQUEST:\r\n" . $cmd);
		$this->lastRequest = $cmd;
		$rs = $this->client->sendCommand($cmd);
		$this->writeLog("RESPONSE:\r\n" . $rs);
		$this->lastResponse = $rs;
		return $this->parseResult($rs);
	}
	
	/*public function logout($clid='', $password='') {
        
        for($i=1;$i<5500;$i++);
        $params = array(
			'clid' => $clid ? $clid : $this->config['user'],
		);
		$password = $password ? $password : $this->config['pass'];
		$cltrid = 'client' . $params['clid'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($params['clid'] . md5($password) . $cltrid . 'logout');
		$cmd = $this->buildCommand('client', 'Logout', $params, $cltrid, $chksum);
		if ( $this->client ) {
			$this->writeLog("REQUEST:\r\n" . $cmd);
			$this->lastRequest = $cmd;
			$rs = $this->client->sendCommand($cmd);
			$this->writeLog("RESPONSE:\r\n" . $rs);
			$this->lastResponse = $rs;
			return $this->parseResult($rs);
		}
		return true;
    }*/
	
	protected function buildCommand($category, $action, $params, $cltrid, $chksum) {
		$xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\r\n
<request>\r\n       
	<category>".htmlentities($category)."</category>\r\n
	<action>".htmlentities($action)."</action>\r\n
	<params>\r\n
";
		foreach ( $params as $k=>$v ) {
			$k = htmlentities($k);
			if ( is_array($v) ) {
				foreach ( $v as $v2 ) {
					$v2 = htmlentities($v2);
					$xml .= "		<param name=\"{$k}\">{$v2}</param>\r\n
";
				}
			} else {
				$v = htmlentities($v);
				$xml .= "		<param name=\"{$k}\">{$v}</param>\r\n
";
			}
		}
		$xml .= "	</params>\r\n
	<cltrid>".htmlentities($cltrid)."</cltrid>\r\n
	<chksum>".htmlentities($chksum)."</chksum>\r\n
</request>\r\n
";
		return $xml;
	}
	
	protected function request($cmd) {
		if ( !$this->client ) {
			if ( !$this->login() ) return false;
		}
		$this->writeLog("REQUEST:\r\n" . $cmd);
		$this->lastRequest = $cmd;
		$rs = $this->client->sendCommand($cmd);
		$this->writeLog("RESPONSE:\r\n" . $rs);
		$this->lastResponse = $rs;
		return $this->parseResult($rs);
	}
	
	protected function parseResult($rs) {
		$rs = preg_replace('/>\s*</', '><', $rs);
		if ( preg_match('/<code>(.*)<\/code>/', $rs, $match) ) {
			$code = intval($match[1]);
		} else $code = -1;
		if ( preg_match('/<msg>(.*)<\/msg>/', $rs, $match) ) {
			$msg = $match[1];
		} else $msg = 'null';
		if ( preg_match('/<value>(.*)<\/value>/', $rs, $match) ) {
			$value = $match[1];
		} else $value = 'null';
		if ( preg_match('/<cltrid>(.*)<\/cltrid>/', $rs, $match) ) {
			$cltrid = $match[1];
		} else $cltrid = 'null';
		if ( preg_match('/<svtrid>(.*)<\/svtrid>/', $rs, $match) ) {
			$svtrid = $match[1];
		} else $svtrid = 'null';
		if ( preg_match('/<chksum>(.*)<\/chksum>/', $rs, $match) ) {
			$chksum = $match[1];
		} else $chksum = 'null';
		if ( preg_match('/<category>(.*)<\/category>/', $rs, $match) ) {
			$category = $match[1];
		} else $category = 'null';
		if ( preg_match('/<action>(.*)<\/action>/', $rs, $match) ) {
			$action = $match[1];
		} else $action = 'null';
		$this->lastResult = array(
			'category' => $category,
			'action' => $action,
			'code' => $code,
			'msg' => $msg,
			'value' => $value,
			'cltrid' => $cltrid,
			'svtrid' => $svtrid,
			'chksum' => $chksum,
		);
		if ( preg_match('/<resData>([\s\S]*)<\/resData>/', $rs, $match) ) {
			$resData = $match[1];
		} else $resData = '';
		if ( $code >= 1000 && $code < 2000 ) {
			if ( !$resData ) return true;
			if ( preg_match_all('/<data name=\"(.*)\">([\s\S]*)<\/data>/U', $resData, $match, PREG_SET_ORDER) ) {
				$data = array();
				foreach ( $match as $v ) {
					if ( isset($data[html_entity_decode($v[1])]) ) {
						if ( is_array($data[html_entity_decode($v[1])]) ) {
							$data[html_entity_decode($v[1])][] = html_entity_decode($v[2]);
						} else {
							$data[html_entity_decode($v[1])] = array($data[html_entity_decode($v[1])], html_entity_decode($v[2]));
						}
					} else {
						$data[html_entity_decode($v[1])] = html_entity_decode($v[2]);
					}
				}
				$this->lastResult['resData'] = $data;
			}
			return true;
		}
		return false;
	}
	
	public function getLastResult($key='') {
		return $key=='' ? $this->lastResult : $this->lastResult[$key];
	}
	
	public function getLastRequest() {
		return $this->lastRequest;
	}
	
	public function getLastResponse() {
		return $this->lastResponse;
	}
	
	public function getLastResultDescription() {
	    return $this->lastResult['msg'].'('.$this->lastResult['code'].')';
	}
	
	private function writeLog($str) {
		$filename = $this->config['log_path'] . 'api_client-' . date('Ymd') . '.log';
		$fp = fopen($filename, 'a+');
		if ( $fp ) {
			$str = preg_replace('/>\s*</', '><', $str);
			$str = '[' . date('Y-m-d H:i:s') . ']' . $str . "\r\n";
			fwrite($fp, $str);
			fclose($fp);
		}
		chmod($filename, 0666);
	}
	
    /*public function __destruct() {
        $this->logout();
    }*/
}

class onlinenic_ApiDomain extends onlinenic_ApiClient {
	
	public function checkDomain($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'checkdomain' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'CheckDomain', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}
	
	public function infoDomain($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'infodomain' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'InfoDomain', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}
	
	public function createDomain($domainType, $mltype, $domain, $period, $dns, $password, $registrant, $admin='', $tech='', $billing='', $ced='', $whoistype='', $publish='', $premium='', $noticeId='', $notAfter='', $notAccept='') {
		$params = array(
				'domaintype' => $domainType,
				'mltype' => $mltype,
				'domain' => $domain,
				'period' => $period,
				'dns' => $dns,
				'registrant' => $registrant,
				'password' => $password,
				);
		if ( $admin ) $params['admin'] = $admin;
		if ( $tech ) $params['tech'] = $tech;
		if ( $billing ) $params['billing'] = $billing;
		if ( $ced ) $params['ced'] = $ced;
		if ( $whoistype ) $params['whoistype'] = $whoistype;
		if ( $publish ) $params['publish'] = $publish;
		if ( $premium ) $params['premium'] = $premium;
		if ( $noticeId ) $params['noticeId'] = $noticeId;
		if ( $notAfter ) $params['notAfter'] = $notAfter;
		if ( $notAccept ) $params['notAccept'] = $notAccept;
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		if ( $domainType == 902 ) {
			$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'createdomain' . $domainType . $domain . $period . $dns[0] . $dns[1] . $registrant . $password);
		} else if ( $domainType == 905 ) {
			$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'createdomain' . $domainType . $domain . $period . $dns[0] . $dns[1] . $registrant . $admin . $tech . $billing . $ced . $password);
		} else {
			$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'createdomain' . $domainType . $domain . $period . $dns[0] . $dns[1] . $registrant . $admin . $tech . $billing . $password);
		}
		$cmd = $this->buildCommand('domain', 'CreateDomain', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}
	
	public function renewDomain($domainType, $domain, $period) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
			'period' => $period,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'renewdomain' . $domainType . $domain . $period);
		$cmd = $this->buildCommand('domain', 'RenewDomain', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function deleteDomain($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'deldomain' . $domainType . $domain . $period);
		$cmd = $this->buildCommand('domain', 'DeleteDomain', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function infoDomainExtra($domainType, $domain) {
        $params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'infodomainextra' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'InfoDomainExtra', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function updateDomainExtra($domainType, $domain, $addExtra, $remExtra) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		if ($addExtra) $params['addextra'] = $addExtra;
		if ($remExtra) $params['remextra'] = $remExtra;
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatedomainextra' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'UpdateDomainExtra', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function updateDomainStatus($domainType, $domain, $addStatus, $remStatus) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		if ( $addStatus ) $params['addstatus'] = $addStatus;
		if ( $remStatus ) $params['remstatus'] = $remStatus;
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatedomainstatus' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'UpdateDomainStatus', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function updateDomainDns($domainType, $domain, $nameserver) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
			'nameserver' => $nameserver,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatedomaindns' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'UpdateDomainDns', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function updateDomainPwd($domainType, $domain, $password) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
			'password' => $password,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatedomainpwd' . $domainType . $domain . $password);
		$cmd = $this->buildCommand('domain', 'UpdateDomainPwd', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function getAuthcode($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'getauthcode' . $domainType . $domain . $period);
		$cmd = $this->buildCommand('domain', 'GetAuthcode', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function checkContact($domainType, $contactId) {
		$params = array(
			'domaintype' => $domainType,
			'contactid' => $contactId,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'checkcontact' . $domainType . $contactId);
		$cmd = $this->buildCommand('domain', 'CheckContact', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function createContact($domainType, $name, $org, $country, $province, $city, $street, $postalcode, $voice, $fax, $email, $password, $extInfo) {
		$params = array(
			'domaintype' => $domainType,
		);
		if ( $name ) $params['name'] = $name;
		if ( $org ) $params['org'] = $org;
		if ( $country ) $params['country'] = $country;
		if ( $province ) $params['province'] = $province;
		if ( $city ) $params['city'] = $city;
		if ( $street ) $params['street'] = $street;
		if ( $postalcode ) $params['postalcode'] = $postalcode;
		if ( $voice ) $params['voice'] = $voice;
		if ( $fax ) $params['fax'] = $fax;
		if ( $email ) $params['email'] = $email;
		if ( $password ) $params['password'] = $password;
		if ( is_array($extInfo) ) {
			foreach( $extInfo as $extName=>$extVal ) {
				if ( $extVal ) $params[$extName] = $extVal;
			}
		}
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'createcontact'. $domainType . $name . $org . $email);
		$cmd = $this->buildCommand('domain', 'CreateContact', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function updateContact($domainType, $domain, $contactType, $name, $org, $country, $province, $city, $street, $postalcode, $voice, $fax, $email, $password, $extInfo) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
			'contacttype' => $contactType,
		);
		if ( $name ) $params['name'] = $name;
		if ( $org ) $params['org'] = $org;
		if ( $country ) $params['country'] = $country;
		if ( $province ) $params['province'] = $province;
		if ( $city ) $params['city'] = $city;
		if ( $street ) $params['street'] = $street;
		if ( $postalcode ) $params['postalcode'] = $postalcode;
		if ( $voice ) $params['voice'] = $voice;
		if ( $fax ) $params['fax'] = $fax;
		if ( $email ) $params['email'] = $email;
		if ( $password ) $params['password'] = $password;
		if ( is_array($extInfo) ) {
			foreach( $extInfo as $extName=>$extVal ) {
				if ( $extVal ) $params[$extName] = $extVal;
			}
		}
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatecontact'. $domainType . $domain. $contactType);
		$cmd = $this->buildCommand('domain', 'UpdateContact', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function changeRegistrant($domainType, $domain, $regtype, $name, $org, $email) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
			
		);
		if ($regtype) $params['regtype'] = $regtype;
		if ($name) $params['name'] = $name;
		if ($org) $params['org'] = $org;
		if ($email) $params['email'] = $email;
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'changeregistrant' . $domainType . $domain . $name . $org . $email);
		$cmd = $this->buildCommand('domain', 'ChangeRegistrant', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function queryEuTrade($domain) {
		$params = array(
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'queryEuTrade' . $domain);
		$cmd = $this->buildCommand('domain', 'queryEuTrade', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}
	
	public function checkHost($domainType, $hostName) {
	    $params = array(
	    	'domaintype' => $domainType,
	        'hostname' => $hostName,	   
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'checkhost' . $domainType . $hostName);
	    $cmd = $this->buildCommand('domain', 'CheckHost', $params, $cltrid, $chksum);
	    return $this->request($cmd);	    
	}
	
	public function infoHost($domainType, $hostName) {
	   $params = array(
	        'domaintype' => $domainType,
	        'hostname' => $hostName,	   
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'infohost' . $domainType . $hostName);
	    $cmd = $this->buildCommand('domain', 'InfoHost', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function createHost($domainType, $hostName, $addr='') {
	    $params = array(
	        'domaintype' => $domainType,
	        'hostname' => $hostName,
	    );
	    if ($addr != '') {
	        $params['addr'] = $addr;
	    }
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'createhost' . $domainType . $hostName . $addr);
	    $cmd = $this->buildCommand('domain', 'CreateHost', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function updateHost($domainType, $hostName, $addAddr, $remAddr) {
	    $params = array(
	    	'domaintype' => $domainType,
	        'hostname' => $hostName,
	        'addaddr' => $addAddr,
	        'remaddr' => $remAddr,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatehost' . $domainType . $hostName . $addAddr . $remAddr);
	    $cmd = $this->buildCommand('domain', 'UpdateHost', $params, $cltrid, $chksum);
	    return $this->request($cmd);    
	}
	
	public function deleteHost($domainType, $hostName) {
	    $params = array(
	    	'domaintype' => $domainType,
	        'hostname' => $hostName,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'deletehost' . $domainType . $hostName);
	    $cmd = $this->buildCommand('domain', 'DeleteHost', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}

	public function infoIDShield($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'infoidshield' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'InfoIDShield', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function appIDShield($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'appidshield' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'AppIDShield', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function updateIDShield($domainType, $domain, $status) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
			'status' => $status,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updateidshield' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'UpdateIDShield', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function renewIDShield($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'renewidshield' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'RenewIDShield', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function deleteIDShield($domainType, $domain) {
		$params = array(
			'domaintype' => $domainType,
			'domain' => $domain,
		);
		$cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
		$chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'deleteidshield' . $domainType . $domain);
		$cmd = $this->buildCommand('domain', 'DeleteIDShield', $params, $cltrid, $chksum);
		return $this->request($cmd);
	}

	public function getTmNotice($domainType, $lookupKey) {
	    $params = array(
	    	'domaintype' => $domainType,
	        'lookupkey' => $lookupKey,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'gettmnotice' . $domainType . $lookupKey);
	    $cmd = $this->buildCommand('domain', 'GetTmNotice', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function getDomainPrice($domainType, $domain, $op, $period) {
	    $params = array(
	    	'domaintype' => $domainType,
	        'domain' => $domain,
	    	'op' => $op,
	    	'period' => $period,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'getdomainprice' . $domainType . $domain . $op . $period);
	    $cmd = $this->buildCommand('domain', 'GetDomainPrice', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function queryCustTransfer($domainType, $domain, $op) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	        'op' => $op,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'querycusttransfer' . $domainType . $domain . $op);
	    $cmd = $this->buildCommand('domain', 'QueryCustTransfer', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function requestCustTransfer($domainType, $domain, $password, $curID) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	        'password' => $password,
	        'curID' => $curID,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'requestcusttransfer' . $domainType . $domain . $password . $curID);
	    $cmd = $this->buildCommand('domain', 'RequestCustTransfer', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function custTransferSetPwd($domainType, $domain, $password) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	        'password' => $password,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'custtransfersetpwd' . $domainType . $domain . $password);
	    $cmd = $this->buildCommand('domain', 'CustTransferSetPwd', $params, $cltrid, $chksum);
	    return $this->request($cmd);
	}
	
	public function queryRegTransfer($domainType, $domain) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'queryregtransfer' . $domainType . $domain);
	    $cmd = $this->buildCommand('domain', 'QueryRegTransfer', $params, $cltrid, $chksum);
	    return $this->request($cmd);     
	}
	
	public function requestRegTransfer($domainType, $domain, $mailWay) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	        'mailway' => $mailWay,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'requestregtransfer' . $domainType . $domain);
	    $cmd = $this->buildCommand('domain', 'RequestRegTransfer', $params, $cltrid, $chksum);
	    return $this->request($cmd); 
	}
	
	public function cancelRegTransfer($domainType, $domain) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'cancelregtransfer' . $domainType . $domain);
	    $cmd = $this->buildCommand('domain', 'CancelRegTransfer', $params, $cltrid, $chksum);
	    return $this->request($cmd); 
	    
	}
	
	public function updateXxxMemberId($domainType, $domain, $memberId) {
	    $params = array(
	        'domaintype' => $domainType,
	        'domain' => $domain,
	        'memberid' => $memberId,
	    );
	    $cltrid = 'whmcs' . $this->config['user'] . date('ymdhis') . rand(1000, 9999);
	    $chksum = md5($this->config['user'] . md5($this->config['pass']) . $cltrid . 'updatexxxmemberid' . $domainType . $domain . $memberId);
	    $cmd = $this->buildCommand('domain', 'UpdateXxxMemberId', $params, $cltrid, $chksum);
	    return $this->request($cmd); 
	}
	
	public function getDomainTypeByTld($tld) {
	    $tld = strtolower($tld);
	    switch($tld) {
	        case 'com': $domainType = 0; break;
	        case 'net': $domainType = 0; break;
	        case 'tw': $domainType=302; break;
	        case 'tv': $domainType=400; break;
	        case 'cc': $domainType=600; break;
	        case 'cc': $domainType=610; break;
	        case 'biz': $domainType=800; break;
	        case 'name': $domainType=804; break;
	        case 'info': $domainType=805; break;
	        case 'us': $domainType=806; break;
	        case 'org': $domainType=807; break;
	        case 'in': $domainType=808; break;
            case 'co.uk': $domainType=901; break;
            case 'org.uk': $domainType=901; break;
            case 'plc.uk': $domainType=901; break;
            case 'me.uk': $domainType=901; break;
	        case 'eu': $domainType=902; break;
	        case 'mobi': $domainType=903; break;
	        case 'asia': $domainType=905; break;
	        case 'me': $domainType=906; break;
	        case 'tel': $domainType=907; break;
	        default: $domainType = 9999; break;
	    }
	    return $domainType;
	}
	
	public function generatePwd($len = 10){
        $isint = $isstr = $isspe = 0;
        $ascii = 0;
        $buff = '';
        for ($i = 0; $i < $len; $i ++) {
            do {
                $ascii = mt_rand(33, 126);
            } while (34 == $ascii || 38 == $ascii || 39 == $ascii || 59 == $ascii || 60 == $ascii || 62 == $ascii || 92 == $ascii);
            $buff .= chr($ascii);
            
            if ($ascii >= 48 && $ascii <= 57) {
                $isint ++;
            } else { 
                if (($ascii >= 65 && $ascii <= 90) || ($ascii >= 97 && $ascii <= 122)) {
                    $isstr ++;
                } else {
                    $isspe ++;
                }
            }
        }
        if (0 == $isint || 0 == $isstr || 0 == $isspe) {
            $buff = substr($buff, 0, - 3);
            $buff .= '-';
            $buff .= chr(mt_rand() % 26 + 97);
            $buff .= chr(mt_rand() % 10 + 48);
        }
        return $buff;
    }
    
    public function compareNameserverExtAndTld($nameserver, $tld) {
        $p = strrpos($nameserver, '.');
        if (false === $p) {
            return strcasecmp($nameserver, $tld) == 0 ? true : false;
        }
        $nameserverExt = substr($nameserver, $p+1);
        return strcasecmp($nameserverExt, $tld) == 0 ? true : false;
    }
    
    public function getUsDomainApplicationPurpose($param) {
        switch($param) {
            case 'Business use for profit':
                $appPurpose = 'P1'; break;
            case 'Non-profit business':
            case 'Club':
            case 'Association':
            case 'Religious Organization':
                $appPurpose = 'P2'; break;
            case 'Personal Use':
                $appPurpose = 'P3'; break;
            case 'Educational purposes':
                $appPurpose = 'P4'; break;
            case 'Government purposes':
                $appPurpose = 'P5'; break;
            default:
                $appPurpose = 'P2'; break;
                break;
        }
        return $appPurpose;
    }
    
    public function getUkDomainOrgType($param) {
        switch($param) {
            case 'Individual': $orgType = 'IND'; break;
            case 'UK Limited Company': $orgType = 'LTD'; break;
            case 'UK Public Limited Company': $orgType = 'PLC'; break;
            case 'UK Partnership': $orgType = 'PTNR'; break;
            case 'UK Limited Liability Partnership': $orgType = 'LLP'; break;
            case 'Sole Trader': $orgType = 'STRA'; break;
            case 'UK Registered Charity': $orgType = 'RCHAR'; break;
            case 'UK Entity (other)': $orgType = 'OTHER'; break;
            case 'Foreign Organization': $orgType = 'FCORP'; break;
            case 'Other foreign organizations': $orgType = 'FOTHER'; break;
            case 'UK Industrial/Provident Registered Company': $orgType = 'IP'; break;
            case 'UK School': $orgType = 'SCH'; break;
            case 'UK Government Body': $orgType = 'GOV'; break;
            case 'UK Corporation by Royal Charter': $orgType = 'CRC'; break;
            case 'UK Statutory Body': $orgType = 'STAT'; break;
            case 'Non-UK Individual': $orgType = 'FIND'; break;
            default: $orgType = 'OTHER'; break;
        }
        return $orgType;
    }
    
    public static function getComNetMltypeByIDNLang($idnLang) {
        $mltypes = array(
            'Afrikaans'=>10301,
            'Albanian'=>12003,
            'Arabic'=>181,
            'Aragonese'=>12007,
            'Armenian'=>12009,
            'Assamese'=>12011,
            'Asturian'=>12012,
            'Avestan'=>12014,
            'Awadhi'=>12016,
            'Azerbaijani'=>12018,
            'Balinese'=>12019,
            'Baluchi'=>12022,
            'Basa'=>12024,
            'Bashkir'=>12026,
            'Basque'=>12029,
            'Belarusian'=>12031,
            'Bengali'=>12033,
            'Bhojpuri'=>12035,
            'Bosnian'=>12036,
            'Bulgarian'=>12037,
            'Burmese'=>163,
            'Carib'=>12041,
            'Catalan'=>10302,
            'Chechen'=>12045,
            'Chinese'=>1,
            'Chuvash'=>12047,
            'Coptic'=>12050,
            'Corsican'=>12051,
            'Croatian'=>10201,
            'Croatian'=>10201,
            'Czech'=>10202,
            'Danish'=>10101,
            'Divehi'=>12054,
            'Dogri'=>12056,
            'Dutch'=>10102,
            'English'=>0,
            'Estonian'=>10401,
            'Faroese'=>12063,
            'Fijian'=>12001,
            'Finnish'=>10104,
            'French'=>10901,
            'Frisian'=>12005,
            'Gaelic'=>12008,
            'Georgian'=>12010,
            'German'=>10106,
            'Gondi'=>12013,
            'Greek'=>10701,
            'Gujarati'=>154,
            'Hebrew'=>180,
            'Hindi'=>12020,
            'Hungarian'=>10203,
            'Icelandic'=>10107,
            'Indic'=>12027,
            'Indonesian'=>12030,
            'Ingush'=>12032,
            'Irish'=>10108,
            'Italian'=>10109,
            'Japanese'=>3,
            'Javanese'=>12038,
            'Kashmiri'=>12039,
            'Kazakh'=>12042,
            'Khmer'=>12043,
            'Kirghiz'=>12046,
            'Korean'=>4,
            'Kurdish'=>12048,
            'Lao'=>161,
            'Latvian'=>10403,
            'Lithuanian'=>10404,
            'Luxembourgish'=>12052,
            'Macedonian'=>12053,
            'Malay'=>12057,
            'Malayalam'=>159,
            'Maltese'=>10304,
            'Maori'=>12061,
            'Moldavian'=>12062,
            'Mongolian'=>187,
            'Nepali'=>12002,
            'Norwegian'=>10110,
            'Oriya'=>12004,
            'Ossetian'=>12006,
            'Panjabi'=>11502,
            'Persian'=>188,
            'Polish'=>10204,
            'Portuguese'=>10111,
            'Pushto'=>12015,
            'Rajasthani'=>12017,
            'Romanian'=>10205,
            'Russian'=>12021,
            'Samoan'=>12023,
            'Sanskrit'=>12025,
            'Sardinian'=>12028,
            'Serbian'=>10208,
            'Sindhi'=>12034,
            'Sinhalese'=>160,
            'Slovak'=>10206,
            'Slovenian'=>10207,
            'Somali'=>12040,
            'Spanish'=>10112,
            'Swahili'=>12044,
            'Swedish'=>10113,
            'Syriac'=>10501,
            'Tajik'=>12049,
            'Tamil'=>156,
            'Telugu'=>157,
            'Thai'=>183,
            'Tibetan'=>162,
            'Turkish'=>10902,
            'Ukrainian'=>12055,
            'Urdu'=>12058,
            'Uzbek'=>12059,
            'Vietnamese'=>11501,
            'Welsh'=>11401,
            'Yiddish'=>12064,
        );
        return isset($mltypes[$idnLang]) ? $mltypes[$idnLang] : '';
    }
    
    public static function getOrgMltypeByIDNLang($idnLang) {
        $mltypes = array(
            'Belarusian'=>514,
            'Bosnian'=>513,
            'Bulgarian'=>515,
            'Danish'=>501,
            'English'=>0,
            'German'=>502,
            'Hungarian'=>503,
            'Icelandic'=>504,
            'Korean'=>505,
            'Latvian'=>506,
            'Lithuanian'=>507,
            'Macedonian'=>516,
            'Polish'=>508,
            'Russian'=>517,
            'Serbian'=>518,
            'Simplied-Chinese'=>511,
            'Spanish'=>509,
            'Swedish'=>510,
            'Traditional-Chinese'=>512,
            'Ukrainian'=>519,
        );
        return isset($mltypes[$idnLang]) ? $mltypes[$idnLang] : '';
    }
    
    public static function getBizMltypeByIDNLang($idnLang) {
        $mltypes = array(
            'Chinese'=>1,
            'Danish'=>2,
            'English'=>0,
            'German'=>3,
            'Icelandic'=>4,
            'Japanese'=>5,
            'Korean'=>9,
            'Norwegian'=>6,
            'Spanish'=>7,
            'Swedish'=>8,
        );
        return isset($mltypes[$idnLang]) ? $mltypes[$idnLang] : '';
    }
}

function onlinenic_getApiConfig($params) {
	$username = $params['Username'];
	$password = $params['Password'];
	$testmode = $params['TestMode'];
	$config = array(
		'server' => $testmode ? '218.5.81.149' : 'www.onlinenic.com',
		'port' => '30009',
		'user' => $testmode ? '135610' : $username,
		'pass' => $testmode ? '654123' : $password,
		'timeout' => 60, //The connection timeout, in seconds.
		'log_record' => true,//Record the log file
		'log_path' => '/apilogs/',
	);
	return $config;
}

function onlinenic_getDomainType($tld) {
	$api = new onlinenic_ApiDomain(array());
	return $api->getDomainTypeByTld($tld);
}

function onlinenic_getApiClient($params, $productClass='Domain') {
	$api = new onlinenic_ApiDomain(onlinenic_getApiConfig($params));
	return $api;
}

function onlinenic_getConfigArray() {
	$configarray = array(
	 "Username" => array( "Type" => "text", "Size" => "20", "Description" => "Enter your Onlinenic username here", ),
	 "Password" => array( "Type" => "password", "Size" => "20", "Description" => "Enter your Onlinenic password here", ),
	 "TestMode" => array( "Type" => "yesno", "Description" => "Tick on to connect to testing account and server. No password required.For Support：http://support.onlinenic.com", ),
	);
	return $configarray;
}

function onlinenic_GetNameservers($params) {
    $tld = $params['tld'];
	$sld = $params['sld'];
	$nameservers = array();
	$api = onlinenic_getApiClient($params);
	$domainType = $api->getDomainTypeByTld($tld);
	$rs = $api->infoDomain($domainType, $sld . "." . $tld);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            GetNamveServers,
            array ($tld,$sld,$nameservers),
            $api->getLastResult());
	
	$domainInfo = $api->getLastResult("resData");
	$nameservers = $domainInfo['dns'];
	$dns_num = count($nameservers);
	for ($i = 0; $i < $dns_num; $i ++) {
		if (isset($nameservers[$i]) && ! empty($nameservers[$i]) && strlen($nameservers[$i]) > 3) {
			$j = $i + 1;
			$values['ns' . $j] = $nameservers[$i];
		}
	}
	return $values;
}

function onlinenic_SaveNameservers($params) {
    $tld = $params['tld'];
    $sld = $params['sld'];
	$nameservers = array();
	for ($i = 1; $i < 6; $i ++) {
		if (strlen($params['ns' . $i]) > 3 && isset($params['ns' . $i]) && ! empty($params['ns' . $i]))
			array_push($nameservers, $params['ns' . $i]);
	}
	$api = onlinenic_getApiClient($params);
	$domainType = $api->getDomainTypeByTld($tld);
	$rs = $api->updateDomainDns($domainType, $sld . "." . $tld, $nameservers);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            SaveNameservers,
            array ($tld,$sld,$nameservers),
            $api->getLastResult());
	
	return $values;
}

function onlinenic_GetRegistrarLock($params) {

    $tld = $params['tld'];
    $sld = $params['sld'];
    $lockstatus = "unlocked";
	$api = onlinenic_getApiClient($params);
	$domainType = $api->getDomainTypeByTld($tld);
	$rs = $api->infoDomainExtra($domainType,$sld.'.'.$tld);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	
		//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            GetRegistrarLock,
            array ($tld,$sld),
            $api->getLastResult());
			
	$status = $api->getLastResult("resData");
	if ( $status['status'] == "clientTransferProhibited" )
		$lockstatus = "locked";
	else
		$lockstatus = "unlocked";
	return $lockstatus;
}

function onlinenic_SaveRegistrarLock($params) {
    $tld = $params['tld'];
    $sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	$domainType = $api->getDomainTypeByTld($tld);
	if ($params['lockenabled']=="locked") {
		$addStatus = "clientTransferProhibited";
		$remStatus = "";
		$rs = $api->updateDomainStatus($domainType, $sld . "." . $tld, $addStatus, $remStatus);
	} else {
		$addStatus = "";
		$remStatus = "clientTransferProhibited";
		$rs = $api->updateDomainStatus($domainType, $sld . "." . $tld, $addStatus, $remStatus);
	}
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            SaveRegistrarLock,
            array ($tld,$sld),
            $api->getLastResult());
	
	return $values;
}
#require (ROOTDIR . "/includes/countriescallingcodes.php");
#['country']{
function getcountrycallingcodes($tt){   
	
switch($tt) {

case  'AF' : $countrycode = 93; break; //Afghanistan
case  'AX' : $countrycode = 358; break; //Aland Islands (Finland)
case  'AL' : $countrycode = 355; break; //Albania
case  'DZ' : $countrycode = 213; break; //Algeria
case  'AS' : $countrycode = 684; break; //American Samoa
case  'AD' : $countrycode = 376; break; //Andorra
case  'AO' : $countrycode = 244; break; //Angola
case  'AI' : $countrycode = 1; break; //Anguilla (1 264)
case  'AQ' : $countrycode = 672; break; //Antarctica
case  'AG' : $countrycode = 1; break; //Antigua And Barbuda
case  'AR' : $countrycode = 54; break; //Argentina
case  'AM' : $countrycode = 374; break; //Armenia
case  'AW' : $countrycode = 297; break; //Aruba
case  'AU' : $countrycode = 61; break; //Australia
case  'AT' : $countrycode = 43; break; //Austria
case  'AZ' : $countrycode = 994; break; //Azerbaijan
case  'BS' : $countrycode = 1; break; //Bahamas
case  'BH' : $countrycode = 973; break; //Bahrain
case  'BD' : $countrycode = 880; break; //Bangladesh
case  'BB' : $countrycode = 1; break; //Barbados
case  'BY' : $countrycode = 375; break; //Belarus
case  'BE' : $countrycode = 32; break; //Belgium
case  'BZ' : $countrycode = 501; break; //Belize
case  'BJ' : $countrycode = 229; break; //Benin
case  'BM' : $countrycode = 1; break; //Bermuda
case  'BT' : $countrycode = 975; break; //Bhutan
case  'BO' : $countrycode = 591; break; //Bolivia
case  'BA' : $countrycode = 387; break; //Bosnia And Herzegovina
case  'BW' : $countrycode = 267; break; //Botswana
case  'BV' : $countrycode = 47; break; //Bouvet Island (Norway)
case  'BR' : $countrycode = 55; break; //Brazil
case  'IO' : $countrycode = 246; break; //British Indian Ocean Territory
case  'BN' : $countrycode = 673; break; //Brunei Darussalam
case  'BG' : $countrycode = 359; break; //Bulgaria
case  'BF' : $countrycode = 226; break; //Burkina Faso
case  'BI' : $countrycode = 257; break; //Burundi
case  'KH' : $countrycode = 855; break; //Cambodia
case  'CM' : $countrycode = 237; break; //Cameroon
case  'CA' : $countrycode = 1; break; //Canada
case  'CV' : $countrycode = 238; break; //Cape Verde
case  'KY' : $countrycode = 1; break; //Cayman Islands
case  'CF' : $countrycode = 236; break; //Central African Republic
case  'TD' : $countrycode = 235; break; //Chad
case  'CL' : $countrycode = 56; break; //Chile
case  'CN' : $countrycode = 86; break; //China
case  'CX' : $countrycode = 618; break; //Christmas Island
case  'CC' : $countrycode = 61; break; //Cocos (Keeling) Islands
case  'CO' : $countrycode = 57; break; //Colombia
case  'KM' : $countrycode = 269; break; //Comoros
case  'CG' : $countrycode = 242; break; //Congo
case  'CD' : $countrycode = 243; break; //Congo; break; Democratic Republic
case  'CK' : $countrycode = 682; break; //Cook Islands
case  'CR' : $countrycode = 506; break; //Costa Rica
case  'CI' : $countrycode = 225; break; //Ivory Coast
case  'HR' : $countrycode = 385; break; //Croatia
case  'CU' : $countrycode = 53; break; //Cuba
case  'CY' : $countrycode = 357; break; //Cyprus
case  'CZ' : $countrycode = 420; break; //Czech Republic
case  'DK' : $countrycode = 45; break; //Denmark
case  'DJ' : $countrycode = 253; break; //Djibouti
case  'DM' : $countrycode = 1; break; //Dominica
case  'DO' : $countrycode = 1; break; //Dominican Republic
case  'EC' : $countrycode = 593; break; //Ecuador
case  'EG' : $countrycode = 20; break; //Egypt
case  'SV' : $countrycode = 503; break; //El Salvador
case  'GQ' : $countrycode = 240; break; //Equatorial Guinea
case  'ER' : $countrycode = 291; break; //Eritrea
case  'EE' : $countrycode = 372; break; //Estonia
case  'ET' : $countrycode = 251; break; //Ethiopia
case  'FK' : $countrycode = 500; break; //Falkland Islands (Malvinas)
case  'FO' : $countrycode = 298; break; //Faroe Islands
case  'FJ' : $countrycode = 679; break; //Fiji
case  'FI' : $countrycode = 358; break; //Finland
case  'FR' : $countrycode = 33; break; //France
case  'GF' : $countrycode = 594; break; //French Guiana
case  'PF' : $countrycode = 689; break; //French Polynesia
case  'TF' : $countrycode = false; break; //French Southern Territories
case  'GA' : $countrycode = 241; break; //Gabon
case  'GM' : $countrycode = 220; break; //Gambia
case  'GE' : $countrycode = 995; break; //Georgia
case  'DE' : $countrycode = 49; break; //Germany
case  'GH' : $countrycode = 233; break; //Ghana
case  'GI' : $countrycode = 350; break; //Gibraltar
case  'GR' : $countrycode = 30; break; //Greece
case  'GL' : $countrycode = 299; break; //Greenland
case  'GD' : $countrycode = 1; break; //Grenada
case  'GP' : $countrycode = 590; break; //Guadeloupe
case  'GU' : $countrycode = 1; break; //Guam
case  'GT' : $countrycode = 502; break; //Guatemala
case  'GG' : $countrycode = 44; break; //Guernsey
case  'GN' : $countrycode = 224; break; //Guinea
case  'GW' : $countrycode = 245; break; //Guinea-Bissau
case  'GY' : $countrycode = 592; break; //Guyana
case  'HT' : $countrycode = 509; break; //Haiti
case  'HM' : $countrycode = false; break; //Heard Island & Mcdonald Islands
case  'VA' : $countrycode = 39; break; //Holy See (Vatican City State)
case  'HN' : $countrycode = 504; break; //Honduras
case  'HK' : $countrycode = 852; break; //Hong Kong
case  'HU' : $countrycode = 36; break; //Hungary
case  'IS' : $countrycode = 354; break; //Iceland
case  'IN' : $countrycode = 91; break; //India
case  'ID' : $countrycode = 62; break; //Indonesia
case  'IR' : $countrycode = 98; break; //Iran; break; Islamic Republic Of
case  'IQ' : $countrycode = 964; break; //Iraq
case  'IE' : $countrycode = 353; break; //Ireland
case  'IM' : $countrycode = 44; break; //Isle Of Man
case  'IL' : $countrycode = 972; break; //Israel
case  'IT' : $countrycode = 39; break; //Italy
case  'JM' : $countrycode = 1; break; //Jamaica
case  'JP' : $countrycode = 81; break; //Japan
case  'JE' : $countrycode = 44; break; //Jersey
case  'JO' : $countrycode = 962; break; //Jordan
case  'KZ' : $countrycode = 7; break; //Kazakhstan
case  'KE' : $countrycode = 254; break; //Kenya
case  'KI' : $countrycode = 686; break; //Kiribati
case  'KR' : $countrycode = 82; break; //Korea; break; Democratic Republic Of
case  'KW' : $countrycode = 965; break; //Kuwait
case  'KG' : $countrycode = false; break; // 996; break; //Kyrgyzstan
case  'LA' : $countrycode = 856; break; //Lao People's Democratic Republic
case  'LV' : $countrycode = 371; break; //Latvia
case  'LB' : $countrycode = 961; break; //Lebanon
case  'LS' : $countrycode = 266; break; //Lesotho
case  'LR' : $countrycode = 231; break; //Liberia
case  'LY' : $countrycode = 218; break; //Libyan Arab Jamahiriya
case  'LI' : $countrycode = 423; break; //Liechtenstein
case  'LT' : $countrycode = 370; break; //Lithuania
case  'LU' : $countrycode = 352; break; //Luxembourg
case  'MO' : $countrycode = 853; break; //Macao
case  'MK' : $countrycode = 389; break; //Macedonia; break; Former Yugoslav Rep.
case  'MG' : $countrycode = 261; break; //Madagascar
case  'MW' : $countrycode = 265; break; //Malawi
case  'MY' : $countrycode = 60; break; //Malaysia
case  'MV' : $countrycode = 960; break; //Maldives
case  'ML' : $countrycode = 223; break; //Mali
case  'MT' : $countrycode = 356; break; //Malta
case  'MH' : $countrycode = 692; break; //Marshall Islands
case  'MQ' : $countrycode = 596; break; //Martinique
case  'MR' : $countrycode = 222; break; //Mauritania
case  'MU' : $countrycode = 230; break; //Mauritius
case  'YT' : $countrycode = 269; break; //Mayotte
case  'MX' : $countrycode = 52; break; //Mexico
case  'FM' : $countrycode = false; break; //691; break; //Micronesia; break; Federated States Of
case  'MD' : $countrycode = 373; break; //Moldova; break; Republic Of
case  'MC' : $countrycode = 377; break; //Monaco
case  'MN' : $countrycode = 976; break; //Mongolia
case  'ME' : $countrycode = false; break; //382; break; //Montenegro
case  'MS' : $countrycode = false; break; //1664; break; //Montserrat
case  'MA' : $countrycode = 212; break; //Morocco
case  'MZ' : $countrycode = 258; break; //Mozambique
case  'MM' : $countrycode = 95; break; //Myanmar
case  'NA' : $countrycode = 264; break; //Namibia
case  'NR' : $countrycode = 674; break; //Nauru
case  'NP' : $countrycode = 977; break; //Nepal
case  'NL' : $countrycode = 31; break; //Netherlands
case  'AN' : $countrycode = 599; break; //Netherlands Antilles
case  'NC' : $countrycode = 687; break; //New Caledonia
case  'NZ' : $countrycode = 64; break; //New Zealand
case  'NI' : $countrycode = 505; break; //Nicaragua
case  'NE' : $countrycode = 227; break; //Niger
case  'NG' : $countrycode = 234; break; //Nigeria
case  'NU' : $countrycode = 683; break; //Niue
case  'NF' : $countrycode = false; break; //6723; break; //Norfolk Island
case  'MP' : $countrycode = false; break; //1670; break; //Northern Mariana Islands
case  'NO' : $countrycode = 47; break; //Norway
case  'OM' : $countrycode = 968; break; //Oman
case  'PK' : $countrycode = 92; break; //Pakistan
case  'PW' : $countrycode = 680; break; //Palau
case  'PS' : $countrycode = false; break; //970; break; //Palestinian Territory; break; Occupied
case  'PA' : $countrycode = 507; break; //Panama
case  'PG' : $countrycode = 675; break; //Papua New Guinea
case  'PY' : $countrycode = 595; break; //Paraguay
case  'PE' : $countrycode = 51; break; //Peru
case  'PH' : $countrycode = 63; break; //Philippines
case  'PN' : $countrycode = 64; break; //Pitcairn
case  'PL' : $countrycode = 48; break; //Poland
case  'PT' : $countrycode = 351; break; //Portugal
case  'PR' : $countrycode = 1; break; //Puerto Rico
case  'QA' : $countrycode = 974; break; //Qatar
case  'RE' : $countrycode = 262; break; //Reunion
case  'RO' : $countrycode = 40; break; //Romania
case  'RU' : $countrycode = 7; break; //Russian Federation
case  'RW' : $countrycode = 250; break; //Rwanda
case  'BL' : $countrycode = false; break; //Saint Barthelemy
case  'SH' : $countrycode = 290; break; //Saint Helena
case  'KN' : $countrycode = false; break; //1869; break; //Saint Kitts And Nevis
case  'LC' : $countrycode = 1; break; //Saint Lucia
case  'MF' : $countrycode = false; break; //Saint Martin
case  'PM' : $countrycode = 508; break; //Saint Pierre And Miquelon
case  'VC' : $countrycode = 1; break; //Saint Vincent And Grenadines
case  'WS' : $countrycode = 685; break; //Samoa
case  'SM' : $countrycode = 378; break; //San Marino
case  'ST' : $countrycode = 239; break; //Sao Tome And Principe
case  'SA' : $countrycode = 966; break; //Saudi Arabia
case  'SN' : $countrycode = 221; break; //Senegal
case  'RS' : $countrycode = 381; break; //Serbia
case  'SC' : $countrycode = 248; break; //Seychelles
case  'SL' : $countrycode = 232; break; //Sierra Leone
case  'SG' : $countrycode = 65; break; //Singapore
case  'SK' : $countrycode = 421; break; //Slovakia
case  'SI' : $countrycode = 386; break; //Slovenia
case  'SB' : $countrycode = 677; break; //Solomon Islands
case  'SO' : $countrycode = 252; break; //Somalia
case  'ZA' : $countrycode = 27; break; //South Africa
case  'GS' : $countrycode = false; break; //South Georgia And Sandwich Isl.
case  'ES' : $countrycode = 34; break; //Spain
case  'LK' : $countrycode = 94; break; //Sri Lanka
case  'SD' : $countrycode = 249; break; //Sudan
case  'SR' : $countrycode = 597; break; //Suriname
case  'SJ' : $countrycode = 47; break; //Svalbard And Jan Mayen
case  'SZ' : $countrycode = 268; break; //Swaziland
case  'SE' : $countrycode = 46; break; //Sweden
case  'CH' : $countrycode = 41; break; //Switzerland
case  'SY' : $countrycode = 963; break; //Syrian Arab Republic
case  'TW' : $countrycode = 886; break; //Taiwan; break; Province Of China
case  'TJ' : $countrycode = 992; break; //Tajikistan
case  'TZ' : $countrycode = 255; break; //Tanzania; break; United Republic Of
case  'TH' : $countrycode = 66; break; //Thailand
case  'TL' : $countrycode = 670; break; //Timor-Leste
case  'TG' : $countrycode = 228; break; //Togo
case  'TK' : $countrycode = 690; break; //Tokelau
case  'TO' : $countrycode = 676; break; //Tonga
case  'TT' : $countrycode = false; break; //Trinidad And Tobago
case  'TN' : $countrycode = 216; break; //Tunisia
case  'TR' : $countrycode = 90; break; //Turkey
case  'TM' : $countrycode = 993; break; //Turkmenistan
case  'TC' : $countrycode = false; break; //1649; break; //Turks And Caicos Islands
case  'TV' : $countrycode = 688; break; //Tuvalu
case  'UG' : $countrycode = 256; break; //Uganda
case  'UA' : $countrycode = 380; break; //Ukraine
case  'AE' : $countrycode = 971; break; //United Arab Emirates
case  'GB' : $countrycode = 44; break; //United Kingdom
case  'US' : $countrycode = 1; break; //United States
case  'UM' : $countrycode = false; break; //United States Outlying Islands
case  'UY' : $countrycode = 598; break; //Uruguay
case  'UZ' : $countrycode = 998; break; //Uzbekistan
case  'VU' : $countrycode = 678; break; //Vanuatu
case  'VE' : $countrycode = 58; break; //Venezuela
case  'VN' : $countrycode = 84; break; //Viet Nam
case  'VG' : $countrycode = false; break; //Virgin Islands; break; British
case  'VI' : $countrycode = false; break; //Virgin Islands; break; U.S.
case  'WF' : $countrycode = 681; break; //Wallis And Futuna
case  'EH' : $countrycode = 212; break; //Western Sahara
case  'YE' : $countrycode = 967; break; //Yemen
case  'ZM' : $countrycode = 260; break; //Zambia
case  'ZW' : $countrycode = 263; break; //Zimbabwe
	    }
		return $countrycode;
	}

function onlinenic_RegisterDomain($params)
{
    $tld = $params['tld'];
    $sld = $params['sld'];
    $regperiod = $params['regperiod'];
    /**
     * nameserver
     */
    $nameservers = array();
    $nameservers[] = $params['ns1'];
    $nameservers[] = $params['ns2'];
    if (isset($params['ns3']) && ! empty($params['ns3'])) {
        $nameservers[] = $params['ns3'];
    }
    if (isset($params['ns4']) && ! empty($params['ns4'])) {
        $nameservers[] = $params['ns4'];
    }
    if (isset($params['ns5']) && ! empty($params['ns5'])) {
        $nameservers[] = $params['ns5'];
    }
    $cellRegionCodeRule = "/^\+[0-9]{1,4}\./";
    /**
     * Registrant Details
     */ 
    $RegistrantName = $params['firstname'] . ' ' . $params['lastname'];
    $RegistrantOrg = empty($params['companyname']) ? $RegistrantName : $params['companyname'];
    $RegistrantAddress = $params['address1'];
    $RegistrantAddress .= $params['address2'] ? ' '.$params['address2'] : '';
    $RegistrantCity = $params['city'];
    $RegistrantStateProvince = $params['state'];
    $RegistrantPostalCode = $params['postcode'];
    $RegistrantCountry = $params['country'];
    $RegistrantEmailAddress = $params['email'];
    $RegistrantPhonePrefix = getcountrycallingcodes($params['country']);
    $RegistrantPhone = preg_match($cellRegionCodeRule, $params['phonenumber']) ? $params['phonenumber'] : '+'.$RegistrantPhonePrefix.'.'.$params['phonenumber'];
    $RegistrantFax = $RegistrantPhone;
    /**
     * Admin Details
     */ 
    $AdminName = $params['adminfirstname'] . ' ' . $params['adminlastname'];
    $AdminOrg = empty($params['admincompanyname']) ? $AdminName : $params['admincompanyname'];
    $AdminAddress = $params['adminaddress1'];
    $AdminAddress .= $params['adminaddress2'] ? ' '.$params['adminaddress2'] : '';
    $AdminCity = $params['admincity'];
    $AdminStateProvince = $params['adminstate'];
    $AdminPostalCode = $params['adminpostcode'];
    $AdminCountry = $params['admincountry'];
    $AdminEmailAddress = $params['adminemail'];
    $AdminPhonePrefix = getcountrycallingcodes($params['country']);#$countrycallingcodes[$params['admincountry']];
    $AdminPhone = preg_match($cellRegionCodeRule, $params['adminphonenumber']) ? $params['adminphonenumber'] : '+'.$AdminPhonePrefix.'.'.$params['adminphonenumber'];
    $AdminFax = $AdminPhone;
    
	$api = onlinenic_getApiClient($params);
    $password = $api->generatePwd();
    $domainType = $api->getDomainTypeByTld($tld);
    $domain = $sld . '.' . $tld;
    $domain = onlinenic_Idn::encode($domain);
    $isIDN = preg_match("/^xn--/i", $domain) ? true : false;
    
    $checkRs = $api->checkDomain($domainType, $domain);
    if ($checkRs == true) {
        $checkData = $api->getLastResult('resData');
        if ($checkData['avail'] == 0) {
            return array('error' => 'Domain is already taken');
        } else if (isset($checkData['premium']) && $checkData['premium'] == 1) {
            return array('error' => 'Domain is premium');
        } else if (isset($checkData['lookupkey']) && $checkData['lookupkey'] == 1) {
            return array('error' => 'Domain is TMCH');
        }
    }
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            checkDomain,
            array ($tld,$sld),
            $api->getLastResult());
	
    $registrantExtInfo = array();
    switch($tld) {
        case 'us':
            $registrantExtInfo['AppPurpose'] = $api->getUsDomainApplicationPurpose($params['additionalfields']['Application Purpose']);
            $registrantExtInfo['NexusCategory'] = $params['additionalfields']['Nexus Category'];
            if (in_array($registrantExtInfo['NexusCategory'], array('C31','C32'))) {
                $NexusCountry = $params['additionalfields']['Nexus Country'];//whmcs这个参数放给客户文本输入，不准确。改成信任注册人国家
                $registrantExtInfo['NexusCategory'] .= '/'.$RegistrantCountry;
            }
            break;
        case 'asia':
            /**
             * CED
             */
            $registrantExtInfo['ccLocality']      = $RegistrantCountry;
            $registrantExtInfo['localitySp']      = $RegistrantStateProvince;
            $registrantExtInfo['localityCity']    = $RegistrantCity;
            $registrantExtInfo['legalEntityType'] = $params['additionalfields']['Legal Type'];;
            $registrantExtInfo['identForm']       = $params['additionalfields']['Identity Form'];
            $registrantExtInfo['identNumber']     = $params['additionalfields']['Identity Number'];
            //$registrantExtInfo['otherLEType'] = '';
            //$registrantExtInfo['otherIdentForm'] = '';
            break;
        case 'eu':
            $registrantExtInfo['euflag'] = 0;
            //$euRegistrantTypes = array('Individual'=>'In', 'Corporation'=>'Co');
            $registrantExtInfo['regtype'] = 'Co';
            break;
        case 'uk':
        case 'co.uk':
        case 'org.uk':
        case 'plc.uk':
        case 'me.uk':
        //case 'net.uk':
        //case 'ltd.uk':
            $registrantExtInfo['orgtype'] = $api->getUkDomainOrgType($params['additionalfields']['Legal Type']);
            if (in_array($registrantExtInfo['orgtype'], array('LTD','PLC','LLP','IP','SCH','RCHAR','FCORP'))) {
                $registrantExtInfo['licence'] = $params['additionalfields']['Company ID Number'];
            }
            break;
    }
    /**
     * create 4 contacter
     */
    $createRegistrantRs = $api->createContact($domainType, $RegistrantName, $RegistrantOrg, $RegistrantCountry, $RegistrantStateProvince, $RegistrantCity, $RegistrantAddress, $RegistrantPostalCode, $RegistrantPhone, $RegistrantFax, $RegistrantEmailAddress, $password, $registrantExtInfo);
    if ($createRegistrantRs == false) {
        return array('error' => 'Failed to create Registrant:' . $api->getLastResultDescription());
    }
    $createRegistrantData = $api->getLastResult('resData');
    $registrantId = $createRegistrantData['contactid'];
    
		//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            CreateContactReg,
            array ($domainType, $RegistrantName, $RegistrantOrg, $RegistrantCountry, $RegistrantStateProvince, $RegistrantCity, $RegistrantAddress, $RegistrantPostalCode, $RegistrantPhone, $RegistrantFax, $RegistrantEmailAddress, $password, $registrantExtInfo),
            $api->getLastResult());
	
    if ($tld == 'eu') {
        $billingId = $techId = $adminId = '';
    } else {
        $createAdminRs = $api->createContact($domainType, $AdminName, $AdminOrg, $AdminCountry, $AdminStateProvince, $AdminCity, $AdminAddress, $AdminPostalCode, $AdminPhone, $AdminFax, $AdminEmailAddress, $password, $registrantExtInfo,array());
        if ($createAdminRs == false) {
            return array('error' => 'Failed to create Admin Contacter:' . $api->getLastResultDescription());
        }
        $createAdminData = $api->getLastResult('resData');
        $adminId = $createAdminData['contactid'];
        $billingId = $techId = $adminId;
    }
	
		//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            CreateContactadmin,
            array ($domainType, $AdminName, $AdminOrg, $AdminCountry, $AdminStateProvince, $AdminCity, $AdminAddress, $AdminPostalCode, $AdminPhone, $AdminFax, $AdminEmailAddress, $password, $registrantExtInfo,array()),
            $api->getLastResult());
    
    if ($tld == 'asia') {
        $ced = $registrantId;
    }
	
    /**
     * create domain
     */
    switch($tld) {
        case 'tel':
            $telWhoisTypeConfig = array('Natural Person'=>'natural','Legal Person'=>'legal');
            $whoistype = $telWhoisTypeConfig[$params['additionalfields']['Legal Type']];
            $publish = $params['additionalfields']['WHOIS Opt-out'] == 'on' ? 'n' : 'y';
            break;
    }
    $mltype = 0;
    if ($isIDN) {
        $mltype = '';
    }
    $createDomainRs = $api->createDomain($domainType, $mltype, $domain, $regperiod, $nameservers, $password, $registrantId, $adminId, $techId, $billingId,
        $ced, $whoistype, $publish, $premium='', $noticeId='', $notAfter='', $notAccept='');
    	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            CreateDomain,
            array ($domainType, $mltype, $domain, $regperiod, $nameservers, $password, $registrantId, $adminId, $techId, $billingId,
        $ced, $whoistype, $publish, $premium='', $noticeId='', $notAfter='', $notAccept=''),
            $api->getLastResult());
		
    if ($createDomainRs == false) {
        return array('error' => 'Failed to register Domain:' . $api->getLastResultDescription());
    }
	
    return array('success' => true);
}
	

function onlinenic_TransferDomain($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->requestRegTransfer(onlinenic_getDomainType($tld), $sld.'.'.$tld);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
		//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            TransferDomain,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld),
            $api->getLastResult());
	
	return $values;
}

function onlinenic_RenewDomain($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$regperiod = $params['regperiod'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->renewDomain(onlinenic_getDomainType($tld), $sld.'.'.$tld, $regperiod);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            RenewDomain,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld, $regperiod),
            $api->getLastResult());
	
	
	return $values;
}

function onlinenic_GetContactDetails($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->infoDomain(onlinenic_getDomainType($tld), $sld.'.'.$tld);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            GetContactDetails,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld),
            $api->getLastResult());
	
	$lastResult = $api->getLastResult();
	$values['Registrant']['Full Name'] = $lastResult['resData']['r_name'];
	$values['Registrant']['Company Name'] = $lastResult['resData']['r_org'];
	$values['Registrant']['Address'] = $lastResult['resData']['r_address'];
	$values['Registrant']['City'] = $lastResult['resData']['r_city'];
	$values['Registrant']['State'] = $lastResult['resData']['r_province'];
	$values['Registrant']['Postcode'] = $lastResult['resData']['r_postalcode'];
	$values['Registrant']['Country'] = $lastResult['resData']['r_country'];
	$values['Registrant']['Phone Number'] = $lastResult['resData']['r_telephone'];
	$values['Registrant']['Fax Number'] = $lastResult['resData']['r_fax'];
	$values['Registrant']['Email'] = $lastResult['resData']['r_email'];
	$values['Admin']['Full Name'] = $lastResult['resData']['a_name'];
	$values['Admin']['Company Name'] = $lastResult['resData']['a_org'];
	$values['Admin']['Address'] = $lastResult['resData']['a_address'];
	$values['Admin']['City'] = $lastResult['resData']['a_city'];
	$values['Admin']['State'] = $lastResult['resData']['a_province'];
	$values['Admin']['Postcode'] = $lastResult['resData']['a_postalcode'];
	$values['Admin']['Country'] = $lastResult['resData']['a_country'];
	$values['Admin']['Phone Number'] = $lastResult['resData']['a_telephone'];
	$values['Admin']['Fax Number'] = $lastResult['resData']['a_fax'];
	$values['Admin']['Email'] = $lastResult['resData']['a_email'];
	$values['Tech']['Full Name'] = $lastResult['resData']['t_name'];
	$values['Tech']['Company Name'] = $lastResult['resData']['t_org'];
	$values['Tech']['Address'] = $lastResult['resData']['t_address'];
	$values['Tech']['City'] = $lastResult['resData']['t_city'];
	$values['Tech']['State'] = $lastResult['resData']['t_province'];
	$values['Tech']['Postcode'] = $lastResult['resData']['t_postalcode'];
	$values['Tech']['Country'] = $lastResult['resData']['t_country'];
	$values['Tech']['Phone Number'] = $lastResult['resData']['t_telephone'];
	$values['Tech']['Fax Number'] = $lastResult['resData']['t_fax'];
	$values['Tech']['Email'] = $lastResult['resData']['t_email'];
	return $values;
}

function onlinenic_SaveContactDetails($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
    //$params['contactdetails']['Registrant']['Full Name'] = '';
	//$params['contactdetails']['Registrant']['Company Name'] = '';
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	
#Different UK
	switch($tld){
	  case 'uk':
	    foreach ( array('registrant'=>'Registrant') as $k=>$v ) {
		$rs = $api->updateContact(onlinenic_getDomainType($tld), $sld.'.'.$tld, $k, 
			$params['contactdetails'][$v]['Full Name'], 
			$params['contactdetails'][$v]['Company Name'], 
			$params['contactdetails'][$v]['Country'],
			$params['contactdetails'][$v]['State'],
			$params['contactdetails'][$v]['City'],
			$params['contactdetails'][$v]['Address'],
			$params['contactdetails'][$v]['Postcode'],
			$params['contactdetails'][$v]['Phone Number'],
			$params['contactdetails'][$v]['Fax Number'],
			$params['contactdetails'][$v]['Email'],
			'Ol#'.rand(10000, 99999),
			array()
		    ); 
		if ( !$rs ) {
			$lastResult = $api->getLastResult();
			$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
			return $values;
	                }
	 }break;
		
	case 'co.uk':
	    foreach ( array('registrant'=>'Registrant') as $k=>$v ) {
		$rs = $api->updateContact(onlinenic_getDomainType($tld), $sld.'.'.$tld, $k, 
			$params['contactdetails'][$v]['Full Name'], 
			$params['contactdetails'][$v]['Company Name'], 
			$params['contactdetails'][$v]['Country'],
			$params['contactdetails'][$v]['State'],
			$params['contactdetails'][$v]['City'],
			$params['contactdetails'][$v]['Address'],
			$params['contactdetails'][$v]['Postcode'],
			$params['contactdetails'][$v]['Phone Number'],
			$params['contactdetails'][$v]['Fax Number'],
			$params['contactdetails'][$v]['Email'],
			'Ol#'.rand(10000, 99999),
			array()
		    );
		if ( !$rs ) {
			$lastResult = $api->getLastResult();
			$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
			return $values;
	                }
	}break;
		
	default:
	
	$rs = $api->changeRegistrant(onlinenic_getDomainType($tld), $sld.'.'.$tld,'',
	     $params['contactdetails'][Registrant]['Full Name']);
	  //   $params['contactdetails'][Registrant]['Company Name'],
	  //   $params['contactdetails'][Registrant]['Email']
		
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            changeRegistrant,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld,
	       $params['contactdetails']['Registrant']['Full Name'], 
	       $params['contactdetails']['Registrant']['Company Name'],
	       $params['contactdetails']['Registrant']['Email']),
            $api->getLastResult());
	
	if ( !$rs ) {
			$lastResult = $api->getLastResult();
			$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
			return $values;
		}
	   //Avoid parameters in changeRegistrant from being changed
	     // $params['contactdetails']['Registrant']['Full Name'] = '';
	    //  $params['contactdetails']['Registrant']['Company Name'] = '';
	    //$params['contactdetails']['Registrant']['Email']= '';
	
	    foreach ( array('registrant'=>'Registrant','admin'=>'Admin','tech'=>'Tech') as $k=>$v ) {
		$rs = $api->updateContact(onlinenic_getDomainType($tld), $sld.'.'.$tld, $k, 
			$params['contactdetails'][$v]['Full Name'], 
			$params['contactdetails'][$v]['Company Name'], 
			$params['contactdetails'][$v]['Country'],
			$params['contactdetails'][$v]['State'],
			$params['contactdetails'][$v]['City'],
			$params['contactdetails'][$v]['Address'],
			$params['contactdetails'][$v]['Postcode'],
			$params['contactdetails'][$v]['Phone Number'],
			$params['contactdetails'][$v]['Fax Number'],
			$params['contactdetails'][$v]['Email'],
			'Ol#'.rand(10000, 99999),
			array()
		);
		
		//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            'Save'.$v.'Details',
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld, $k, 
			$params['contactdetails'][$v]['Full Name'], 
			$params['contactdetails'][$v]['Company Name'], 
			$params['contactdetails'][$v]['Country'],
			$params['contactdetails'][$v]['State'],
			$params['contactdetails'][$v]['City'],
			$params['contactdetails'][$v]['Address'],
			$params['contactdetails'][$v]['Postcode'],
			$params['contactdetails'][$v]['Phone Number'],
			$params['contactdetails'][$v]['Fax Number'],
			$params['contactdetails'][$v]['Email'],
			'Ol#'.rand(10000, 99999),
			array()),
            $api->getLastResult());
		
		if ( !$rs ) {
			$lastResult = $api->getLastResult();
			$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
			return $values;
		}
		
	}
	
	break;
	

	return $values;
}}

function onlinenic_TransferSync($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->queryRegTransfer(onlinenic_getDomainType($tld), $sld.'.'.$tld);
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            TransferSync,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld),
            $api->getLastResult());
	
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
	$status = substr($lastResult['resData']['status'], 0, strstr(';', $lastResult['resData']['status']));
	switch ( $status ) {
		case 'transferSuccessfully':
			$values['completed'] = true;
			$rs = $api->infoDomain(onlinenic_getDomainType($tld), $sld.'.'.$tld);
			if ( !$rs ) {
				$lastResult = $api->getLastResult();
				$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
				return $values;
			}
			$lastResult = $api->getLastResult();
			$values['expirydate'] = $lastResult['resData']['exDate'];
			break;
		case 'pendingTransfer':
			$values['error'] = $lastResult['resData']['status'];
			break;
		default:
			$values['failed'] = true;
			$values['reason'] = $lastResult['resData']['status'];
	}
	return $values;
}

function onlinenic_Sync($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->infoDomain(onlinenic_getDomainType($tld), $sld.'.'.$tld);
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            DomainSync,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld),
            $api->getLastResult());
	
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
	$values['active'] = true;
	$values['expired'] = false;
	$values['expiredate'] = $lastResult['resData']['exDate'];
	return $values;
}

function onlinenic_GetEPPCode($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->getAuthcode(onlinenic_getDomainType($tld), $sld.'.'.$tld);
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
	$values['eppcode'] = $lastResult['resData']['password'];
	return $values;
}

function onlinenic_RequestDelete($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->deleteDomain(onlinenic_getDomainType($tld), $sld.'.'.$tld);
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            RequestDelete,
            array (onlinenic_getDomainType($tld), $sld.'.'.$tld),
            $api->getLastResult());
	
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
	$values['eppcode'] = $lastResult['resData']['password'];
	return $values;
}


function onlinenic_RegisterNameserver($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
    $nameserver = $params['nameserver'];
    $ipaddress = $params['ipaddress'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->createHost(onlinenic_getDomainType($tld), $nameserver, $ipaddress);
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            RegisterDNS,
            array (onlinenic_getDomainType($tld), $nameserver, $ipaddress),
            $api->getLastResult());
	
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
    return $values;
}

function onlinenic_ModifyNameserver($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
    $nameserver = $params['nameserver'];
    $currentipaddress = $params['currentipaddress'];
    $newipaddress = $params['newipaddress'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->updateHost(onlinenic_getDomainType($tld), $nameserver, $newipaddress, $currentipaddress);
	
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            ModifyDNS,
            array (onlinenic_getDomainType($tld), $nameserver, $newipaddress, $currentipaddress),
            $api->getLastResult());
	
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
    return $values;
}

function onlinenic_DeleteNameserver($params) {
	$tld = $params['tld'];
	$sld = $params['sld'];
    $nameserver = $params['nameserver'];
	$api = onlinenic_getApiClient($params);
	if ( is_array($api) ) return $api;
	$rs = $api->deleteHost(onlinenic_getDomainType($tld), $nameserver);
	//Module logging
			logModuleCall(
            'OnlineNICDomainV1.3',
            DeleteDNS,
            array (onlinenic_getDomainType($tld), $nameserver),
            $api->getLastResult());
			
	if ( !$rs ) {
		$lastResult = $api->getLastResult();
		$values['error'] = $lastResult['code'] . ' - ' . $lastResult['msg'] . ' - ' . $lastResult['value'];
		return $values;
	}
	$lastResult = $api->getLastResult();
    return $values;
}

?>
